"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var core_2 = require("@ngx-translate/core");
var api_1 = require("api-angular-monitorias-dto/api");
var app_service_1 = require("./app.service");
var I18NComponent = /** @class */ (function () {
    function I18NComponent(utilTranslate, appService) {
        var _this = this;
        this.utilTranslate = utilTranslate;
        this.appService = appService;
        this.langs = [];
        this.master = false;
        api_1.Languages.getAllEnumValues().forEach(function (element) {
            _this.langs.push(element.nameid);
        });
        this.utilTranslate.addLangs(this.langs);
        this.utilTranslate.setDefaultLang(api_1.Languages.SPANISH.nameid);
        this.currentLang = this.appService.getCurrentLanguageInLS();
        if (this.currentLang && this.currentLang.length > 0) { }
        else {
            var browserLang = this.utilTranslate.getBrowserLang();
            this.currentLang = (browserLang.match(/en|es/) ? browserLang : api_1.Languages.ENGLISH.nameid);
            this.appService.saveCurrentLanguageInLS(this.currentLang);
        }
        this.utilTranslate.use(this.currentLang);
        this.setFlag(this.currentLang);
        this.appService.currentLangChanges.subscribe(function (currentLangs) {
            if (!_this.master && (currentLangs === api_1.Languages.ENGLISH.nameid || currentLangs === api_1.Languages.SPANISH.nameid)) {
                _this.currentLang = currentLangs;
                _this.changeLanguage();
            }
        });
    }
    I18NComponent.prototype.changeLanguage = function () {
        this.setLanguage();
        this.appService.saveCurrentLanguageInLS(this.currentLang);
        this.setFlag(this.currentLang);
    };
    I18NComponent.prototype.setFlag = function (flag) {
        flag === api_1.Languages.SPANISH.nameid ? this.flag = api_1.Languages.ENGLISH.nameid : this.flag = api_1.Languages.SPANISH.nameid;
    };
    I18NComponent.prototype.setLanguage = function () {
        this.utilTranslate.use(this.currentLang);
    };
    I18NComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'app-i18n',
                    template: "\n    <select id=\"languagescombobox1\" class=\"combobox\" [(ngModel)]=\"currentLang\" (change)=\"changeLanguage()\">\n        <option *ngFor=\"let element of langs\" [ngValue]=\"element\">{{ element | translate }}</option>\n    </select>\n  ",
                    styles: ["\n    .combobox {\n        margin: 0px;\n        width: 100%;\n        background-color: black;\n        color: white;\n        border: 1px solid white;\n        padding: 2px;\n        font-size: 12px;\n    }\n  "]
                },] },
    ];
    /** @nocollapse */
    I18NComponent.ctorParameters = function () { return [
        { type: core_2.TranslateService, },
        { type: app_service_1.AppService, },
    ]; };
    I18NComponent.propDecorators = {
        "master": [{ type: core_1.Input },],
    };
    return I18NComponent;
}());
exports.I18NComponent = I18NComponent;
//# sourceMappingURL=app.component.js.map